#ifndef __MSPLUGIN_BI__
#define __MSPLUGIN_BI__

#include once "msModelLib.bi"

' return the kind of plugin via Plugin_GetType()
type PluginType as long
const as PluginType eTypeImport                           = &H0001
const as PluginType eTypeExport                           = &H0002
const as PluginType eTypeTool                             = &H0003
const as PluginType eTypeEdit                             = &H0004
const as PluginType eTypeVertex                           = &H0005
const as PluginType eTypeFace                             = &H0006
const as PluginType eTypeAnimate                          = &H0007
const as PluginType eNormalsAndTexCoordsPerTriangleVertex = &H0080


type PluginError as long
const as PluginError eOK    = 0
const as PluginError eError = -1

extern "Windows-MS"

' To build an MilkShape 3D plugin (a windows 32-bit dll)
' you have to implement and export this 3 functions in FreeBASIC

declare function Plugin_GetType as PluginType

declare function Plugin_GetTitle as const zstring ptr

declare function Plugin_Execute(byval pModel as msModel ptr) as PluginError

end extern

' let us say you write an blender file importer

' name your bas file:
' "msBlenderImport_Plugin.bas"

' compile it as dll and the result are:
' "msBlenderImport_Plugin.dll"

' now renname the C++ wrapper "msWrapper.dll" (included in the *.zip file)
' to "msBlenderImport.dll"

' and put both *.dll's
' "msBlenderImport.dll" and "msBlenderImport_Plugin.dll"
' in the MilkeShape 3D folder

' if you execute or restart Milkshape 3D (ms3.exe)
' it scans it own folder for plugin DLL's 
' all dll's with a name starting with "ms" are loaded as plugin

' now Milkshape loads the C++ plugin wrapper you renamed as :
' "msBlenderImport.dll"

' the wrapper msBlenderImport.dll read it's own file name
' "msBlenderImport" and expand the string with "_Plugin.dll"

' Than the C++ plugin wrapper load your fresh created plugin:
' "msBlenderImport_Plugin.dll" in memory and deligate 3 function call's
' (from a Microsoft C++ class) to your exported FreeBASIC functions.

' Thats all :-)

#endif ' __MSPLUGIN_BI__
